# Class _TachyonExporter

java.lang.Object
org.jmol.export.___Exporter
org.jmol.export._TachyonExporter

public class _TachyonExporter extends ___Exporter

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`isSlabEnabled`
`protected int`
`minScreenDimension`
`protected boolean`
`wasPerspective`

### Fields inherited from class ___Exporter

`apertureAngle, backgroundColix, cameraDistance, cameraPosition, center, commandLineOptions, commentChar, degreesPerRadian, depthZ, export3D, exportScale, fileName, fixedRotationCenter, gdata, lightSource, lineWidthMad, out, privateKey, referenceCenter, scalePixelsPerAngstrom, screenHeight, screenWidth, slabZ, solidOnly, tempP1, tempP2, tempP3, tempV1, tempV2, tm, vwr`

## Constructor Summary

Constructors
Constructor
Description
`_TachyonExporter()`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`fillConicalCylinder(P3 screenA, P3 screenB, int madBond, short colix, byte endcaps)`
`protected void`
`fillTriangle(short colix, T3 ptA, T3 ptB, T3 ptC, boolean twoSided)`
`protected String`
`finalizeOutput2()`
`protected P3`
`getScreenNormal(T3 pt, T3 normal, float factor)`
`protected boolean`
`initOutput(Viewer vwr, double privateKey, GData g3d, Map<String,Object> params)`
`protected void`
`initVars()`
`protected void`
`output(T3 pt)`
`protected void`
`outputCircle(int x, int y, int z, float radius, short colix, boolean doFill)`
`protected void`
`outputCone(P3 screenBase, P3 screenTip, float radius, short colix, boolean isBarb)`
`protected void`
`outputCylinder(P3 screenA, P3 screenB, float radius, short colix, boolean withCaps)`
`protected void`
`outputCylinderConical(P3 screenA, P3 screenB, float radius1, float radius2, short colix)`
`protected void`
`outputEllipsoid(P3 center, float radius, double[] coef, short colix)`
`protected void`
`outputFooter()`
`protected void`
`outputHeader()`
`protected void`
`outputSphere(float x, float y, float z, float radius, short colix)`
`protected void`
`outputSurface(T3[] vertices, T3[] normals, short[] colixes, int[][] indices, short[] polygonColixes, int nVertices, int nPolygons, int nTriangles, BS bsPolygons, int faceVertexMax, short colix, Lst<Short> colorList, Map<Short,Integer> htColixes, P3 offset)`
`protected void`
`outputTextPixel(int x, int y, int z, int argb)`
`protected void`
`outputTriangle(T3 ptA, T3 ptB, T3 ptC, short colix)`
`protected void`
`outputVertex(T3 pt, T3 offset)`

### Methods inherited from class ___Exporter

`finalizeOutput, fixScreenZ, getByteCount, getColorList, getConeMesh, getExportDate, getJmolPerspective, getRotationMatrix, getRotationMatrix, getTriad, getTriadC, opacityFractionalFromArgb, opacityFractionalFromColix, output, outputComment, outputJmolPerspective, outputVertices, rgbFractionalFromArgb, rgbFractionalFromColix, round, round, setTempVertex, translucencyFractionalFromColix`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### isSlabEnabled

protected boolean isSlabEnabled

### minScreenDimension

protected int minScreenDimension

### wasPerspective

protected boolean wasPerspective

## Constructor Details

### _TachyonExporter

public _TachyonExporter()

## Method Details

### outputHeader

protected void outputHeader()

Specified by:
  `outputHeader` in class `___Exporter`

### outputFooter

protected void outputFooter()

Overrides:
  `outputFooter` in class `___Exporter`

### output

protected void output(T3 pt)

Specified by:
  `output` in class `___Exporter`

### outputCircle

protected void outputCircle(int x, int y, int z, float radius, short colix, boolean doFill)

### outputCone

protected void outputCone(P3 screenBase, P3 screenTip, float radius, short colix, boolean isBarb)

### outputCylinder

protected void outputCylinder(P3 screenA, P3 screenB, float radius, short colix, boolean withCaps)

### fillConicalCylinder

protected void fillConicalCylinder(P3 screenA, P3 screenB, int madBond, short colix, byte endcaps)

Parameters:
  `screenA` -
  `screenB` -
  `madBond` -
  `colix` -
  `endcaps` -

### outputCylinderConical

protected void outputCylinderConical(P3 screenA, P3 screenB, float radius1, float radius2, short colix)

### outputEllipsoid

protected void outputEllipsoid(P3 center, float radius, double[] coef, short colix)

### outputSurface

protected void outputSurface(T3[] vertices, T3[] normals, short[] colixes, int[][] indices, short[] polygonColixes, int nVertices, int nPolygons, int nTriangles, BS bsPolygons, int faceVertexMax, short colix, Lst<Short> colorList, Map<Short,Integer> htColixes, P3 offset)

Overrides:
  `outputSurface` in class `___Exporter`
Parameters:
  `vertices` - generally unique vertices [0:nVertices)
  `normals` - one per vertex
  `colixes` - one per vertex, or null
  `indices` - one per triangular or quad polygon; may have additional elements beyond vertex indices if faceVertexMax = 3 triangular if faceVertexMax == 3; 3 or 4 if face VertexMax = 4
  `polygonColixes` - face-based colixes
  `nVertices` - vertices[nVertices-1] is last vertex
  `nPolygons` - indices[nPolygons - 1] is last polygon
  `nTriangles` - number of triangular faces required
  `bsPolygons` - number of polygons (triangles or quads)
  `faceVertexMax` - (3) triangles only, indices[][i] may have more elements (4) triangles and quads; indices[][i].length determines
  `colix` - overall (solid) color index
  `colorList` - list of unique color IDs
  `htColixes` - map of color IDs to colorList
  `offset` -

### outputSphere

protected void outputSphere(float x, float y, float z, float radius, short colix)

### outputTextPixel

protected void outputTextPixel(int x, int y, int z, int argb)

### outputTriangle

protected void outputTriangle(T3 ptA, T3 ptB, T3 ptC, short colix)

### initOutput

protected boolean initOutput(Viewer vwr, double privateKey, GData g3d, Map<String,Object> params)

Overrides:
  `initOutput` in class `___Exporter`

### finalizeOutput2

protected String finalizeOutput2()

Overrides:
  `finalizeOutput2` in class `___Exporter`

### outputVertex

protected void outputVertex(T3 pt, T3 offset)

Overrides:
  `outputVertex` in class `___Exporter`

### getScreenNormal

protected P3 getScreenNormal(T3 pt, T3 normal, float factor)

### initVars

protected void initVars()

### fillTriangle

protected void fillTriangle(short colix, T3 ptA, T3 ptB, T3 ptC, boolean twoSided)

Specified by:
  `fillTriangle` in class `___Exporter`